#ifndef FILE_H_
#define FILE_H_

#endif /*FILE_H_*/

#include <stdio.h>
#include <stdlib.h>

struct sConfig
{
	char smip[255];
	char sjip[255];
	short smport;
	short sjport;
	long rollscale;
	long pitchscale;
	long heavescale;
	long yawscale;
	float joy1xmin;
	float joy1xmax;
	float joy1ymin;
	float joy1ymax;
	float joy1rmin;
	float joy1rmax;
	float joy2xmin;
	float joy2xmax;
	float joy2ymin;
	float joy2ymax;
	float joy2rmin;
	float joy2rmax;
	long reserved[20];
};

struct sConfig fconfig;

PtFileSelectionInfo_t info;
   int k;
   FILE *fp;
   
void savefile()
{
	 memset( &info, 0x0, sizeof(PtFileSelectionInfo_t) );
	 
	    k = PtFileSelection( NULL, /* parent */
               NULL, /* pos */
               "Save File", /* title */
               "~",  /*  root_dir, tilde is the home directory
                         specified by $HOME */
               NULL, /*  file_spec filter */
               "Save", /*  label of btn1, the Open button,
                         default is "Open" */
               NULL, /*  label of btn2, the Cancel button,
                         default is "Cancel" */
               NULL, /*  Pt_ARG_FS_FORMAT resource of the
                         PtFileSel widget, default is "nsd" */
               &info, /* PtFileSelectionInfo_t *info
                             structure, must be specified */
               Pt_FSR_CONFIRM_EXISTING | 
               Pt_FSR_SHOW_HIDDEN | 
               Pt_FSR_NO_FCHECK  /* PtFileSelection flags */
               );
    if ( info.ret == Pt_FSDIALOG_BTN1 )
	{
		fp = fopen( info.path, "w" );
        fwrite( &gPlayback, sizeof( struct gsPlayback ), 1, fp );
        fclose( fp );
	}
               
}

void openfile()
{
	 memset( &info, 0x0, sizeof(PtFileSelectionInfo_t) );
	 
	    k = PtFileSelection( NULL, /* parent */
               NULL, /* pos */
               "Open File", /* title */
               "~",  /*  root_dir, tilde is the home directory
                         specified by $HOME */
               NULL, /*  file_spec filter */
               "Open", /*  label of btn1, the Open button,
                         default is "Open" */
               NULL, /*  label of btn2, the Cancel button,
                         default is "Cancel" */
               NULL, /*  Pt_ARG_FS_FORMAT resource of the
                         PtFileSel widget, default is "nsd" */
               &info, /* PtFileSelectionInfo_t *info
                             structure, must be specified */
               Pt_FSR_SHOW_HIDDEN | 
               Pt_FSR_NO_FCHECK  /* PtFileSelection flags */
               );
    if ( info.ret == Pt_FSDIALOG_BTN1 )
	{
		fp = fopen( info.path, "r" );
        fread( &gPlayback, sizeof( struct gsPlayback ), 1, fp );
        fclose( fp );
	}
               
}

void saveconfig()
{
		
		memset( &fconfig, 0x0, sizeof(struct sConfig) );
		strcpy(fconfig.smip, mip);
		strcpy(fconfig.sjip, jip);
		fconfig.smport = mport;
		fconfig.sjport = jport;
		fconfig.joy1xmin = Joy1.Xmin;
		fconfig.joy1xmax = Joy1.Xmax;
		fconfig.joy1ymin = Joy1.Ymin;
		fconfig.joy1ymax = Joy1.Ymax;
		fconfig.joy1rmin = Joy1.Rmin;
		fconfig.joy1rmax = Joy1.Rmax;
		
		fconfig.joy2xmin = Joy2.Xmin;
		fconfig.joy2xmax = Joy2.Xmax;
		fconfig.joy2ymin = Joy2.Ymin;
		fconfig.joy2ymax = Joy2.Ymax;
		fconfig.joy2rmin = Joy2.Rmin;
		fconfig.joy2rmax = Joy2.Rmax;		
		fconfig.pitchscale = VelOut.PitchScale;
		fconfig.rollscale = VelOut.RollScale;
		fconfig.heavescale = VelOut.HeaveScale;
		fconfig.yawscale = VelOut.YawScale;
		 
		
		fp = fopen( "config", "w" );
        fwrite( &fconfig, sizeof( struct sConfig ), 1, fp );
        fclose( fp );
	
}

void openconfig()
{
	char tmp3[255];
		memset( &fconfig, 0x0, sizeof(struct sConfig) );
		fp = fopen( "config", "r" );
        fread( &fconfig, sizeof( struct sConfig ), 1, fp );
        fclose( fp );
        
		strcpy(mip, fconfig.smip);
		strcpy(jip, fconfig.sjip);
		mport = fconfig.smport;
		jport = fconfig.sjport;
		Joy1.Xmin = fconfig.joy1xmin;
		Joy1.Xmax = fconfig.joy1xmax;
		Joy1.Ymin = fconfig.joy1ymin;
		Joy1.Ymax = fconfig.joy1ymax;
		Joy1.Rmin = fconfig.joy1rmin;
		Joy1.Rmax = fconfig.joy1rmax;
		Joy2.Xmin = fconfig.joy2xmin;
		Joy2.Xmax = fconfig.joy2xmax;
		Joy2.Ymin = fconfig.joy2ymin;
		Joy2.Ymax = fconfig.joy2ymax;
		Joy2.Rmin = fconfig.joy2rmin;
		Joy2.Rmax = fconfig.joy2rmax;
		VelOut.PitchScale = fconfig.pitchscale;
		VelOut.RollScale = fconfig.rollscale;
		VelOut.HeaveScale = fconfig.heavescale;
		VelOut.YawScale = fconfig.yawscale;

	PtSetResource(ABW_MIP,	Pt_ARG_TEXT_STRING,	mip,	strlen(mip));
	PtSetResource(ABW_JIP,	Pt_ARG_TEXT_STRING,	jip,	strlen(jip));
	sprintf(tmp3, "%i", (int)mport);
	PtSetResource(ABW_MPORT,	Pt_ARG_TEXT_STRING,	tmp3,	strlen(tmp3));
	sprintf(tmp3, "%i", (int)jport);
	PtSetResource(ABW_JPORT,	Pt_ARG_TEXT_STRING,	tmp3,	strlen(tmp3));
	PtSetResource(ABW_SlRollScale,	Pt_ARG_GAUGE_VALUE,VelOut.RollScale,	sizeof(long));
	PtSetResource(ABW_SlPitchScale,	Pt_ARG_GAUGE_VALUE,VelOut.PitchScale,	sizeof(long));
	PtSetResource(ABW_SlHeaveScale,	Pt_ARG_GAUGE_VALUE,VelOut.HeaveScale,	sizeof(long));
	PtSetResource(ABW_SlYawScale,	Pt_ARG_GAUGE_VALUE,VelOut.YawScale,	sizeof(long));
}