#ifndef GLOBAL_H_
#define GLOBAL_H_

#endif /*GLOBAL_H_*/

long CenterInches = 9;

struct gsState
{
    float MinStrutLength;
    float MaxStrutLength;
    long InRunAccelMax;
    long InRunDecelMax;
    long InRunVelMax;
    long StrutLInches;
    long StrutRInches;
    long StrutBInches;
    long StrutLCounts;
    long StrutRCounts;
    long StrutBCounts;
    long CurrentAccel;
    long CurrentDecel;
    long CurrentVel;

};

struct gsState gState={0};

struct gsConsoleRecord
{
	unsigned long header;
	unsigned short samplenum;
	unsigned char error;
	unsigned char status;
	unsigned short analogout[8];
	unsigned short analogin[8];
	unsigned char outputstate[2];
	unsigned char inputstate[2];
	unsigned long pulsecount;
	long ZCdata;
	long ZDdata;
};
struct gsConsoleRecord gConsole={0};
	

struct gsInputRecord
{
	unsigned short samplenum;
	unsigned char input[10];
	unsigned char output[10];
	unsigned char error;
	unsigned char status;
	
};

struct gsAxisRecord
{
	unsigned short status;
	char switches;
	char stopcode;
	long refpos;
	long motorpos;
	long poserr;
	long auxpos;
	long vel;
	short torque;
	short analog;
};

struct gsAllRecord
{
	long header;
	struct gsInputRecord I;
	struct gsAxisRecord A;
	struct gsAxisRecord B;
	struct gsAxisRecord C;
	struct gsAxisRecord D;
};

struct gsAllRecord gRecord={0};
	
struct gsFeedback
{
    long StrutLPosition;
    long StrutRPosition;
    long StrutBPosition;
    long StrutTPosition;
    
    char RawStateL;
    char RawStateR;
    char RawStateB;
    char RawStateT;
    
    char LBrakeOn;
    char BBrakeOn;
    char RBrakeOn;
    char TBrakeOn;
    
    char MotorLOn;
    char MotorROn;
    char MotorBOn;
    char MotorTOn;
    
    char ButtonState;
    char Buttons;
    char ExtendedIO0;
    char ExtendedIO1;
    char ExtendedIO2;
    char ExtendedIO3;
    float Analog1;
    float Analog2;
    float Analog3;
    float Analog4;
};
struct gsFeedback gfeed={0};

struct Joy
{
	float Xraw;
	float Yraw;
	float Rraw;
	float Xmin;
	float Ymin;
	float Rmin;
	float Xmax;
	float Ymax;
	float Rmax;
	float Xcal;
	float Ycal;
	float Rcal;
};
	
struct Joy Joy1={0};
struct Joy Joy2={0};

struct VelocityOutput
{
	long PitchScale;
	long RollScale;
	long YawScale;
	long HeaveScale;
	
	float VelScale;
	
	float Xvelfinal;
	float Yvelfinal;
	float Zvelfinal;
	float Rvelfinal;
	
	float RollVel;
	float PitchVel;
	float VertVel;
	float YawVel;	
};

struct VelocityOutput VelOut={0};

struct gsPlayback
{
	long numframes;
	long axisA[99999];
	long axisB[99999];
	long axisC[99999];
	long axisD[99999];
	long posA[99999];
	long posB[99999];
	long posC[99999];
	long posD[99999];
};
struct gsPlayback gPlayback;

struct gsLimits
{
	long Xmin;
	long Xmax;
	long Ymin;
	long Ymax;
	long Zmin;
	long Zmax;
	long Rmin;
	long Rmax;
};
struct gsLimits gLimits;

long EStopInvert=0;
long NetFaultBypass=0;
long DoorFaultBypass=0;
long ServoFaultBypass=0;
long AmpFaultBypass=0;
long EStopFaultBypass=0;
long ReactBypass=0;

long UDPFault=0;
long TCPFault=0;
long CODEFault=0;
long NetFault=0;
long DoorFault=0;
long ServoFault=0;
long AmpFault=0;
long AmpID=0;
long EStopFault=0;
long ActiveDisable=0;

long StartTimer=0;
long StopTimer=0;
long EnableTimer=0;
long ActivateWhenReady=0;
long ReactWhenReady=0;
long DropTimer=0;
long HomeTimer=0;
long ApplyTimer=0;
long BurnTimer=0;
long ReconnectTimer=0;
long DoReconnect=0;
long GameTimer=0;
long ReactTimer=0;

long PitchDifferential=0;

long CurrentError=0;

long chkActive=0;
long chkHome=0;
long chkReact=0;

char bInit=0;
char bSInit=0;
char bZero=0;
char bDidZero=0;
char bReady=0;
char bActive=0;
char bHome=0;
char bUnhomed=0;
char bReact=0;
char bReactInit=0;
char bReactStop=0;
char bRecording=0;
char bPlaying=0;
char bRDidZero=0;
char bRZero=0;
long RPOSForward=0;
long RPOSReverse=0;
char bPOSReverse=0;
char bPOSForward=0;
long lPF=0;
long lPR=0;
long lPC=0;
long ForwardSpeed=-5000;
long ReverseSpeed=5000;
char bWasForward=0;
char bWasReverse=0;
char bStartOnLimit=0;
char bEStop=0;
long pCurframe=0;
long rCurframe=0;
char inputbits[8];
char bPOSERR=0;
char bPOWERR=0;

long tTime=0;
long tLimit=0;

char code[2048]={0};
char tmp[255]={0};
char statusnew[65535]={0};
char statusstr[65535]={0};
float js[6]={0};
char recvd[4096]={0};
PtArg_t args[3];
PtCallbackInfo_t cinfo;
PgColor_t scolor;
clock_t zerotime;
clock_t ntftime;
clock_t starttime;
char bStart=0;
void DoJoystick();
void DoJoystickCode();
void DoCode();
void DoZero();
void DoShut();
unsigned long   *flags;
	char tmp2[200];
	PhPoint_t joy1dot;
	PhPoint_t joy2dot;
	unsigned short joy1start;
	unsigned short joy1end;	
	unsigned short joy2start;
	unsigned short joy2end;

void DoUI()
{
	//This function is now only called from debugtimer at 50msec
	
	if(bStart==0 && clock() - starttime > 50000)
	{
		PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
		PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
		PtSetResources( ABW_CACTIVE, 3, args ); 
		bStart=1;
	}
		
	msend( "NTF=1\xD");  //watchdog

    
	//Query Motion Status Records UDP
	msendf("QRIABCD\xD");
	
	//Query Console Status Records UDP
	jsendf("QR\xD");
	
	//Set Point Tracking
//	msend("PT1,1,1,1\xDBG\xD");
	
	//Print Joystick Info
	sprintf(tmp,"Joy1:\n\nX:%f\nY:%f\nR:%f", Joy1.Xcal, Joy1.Ycal, Joy1.Rcal);
    PtSetResource(ABW_mtJoy1Info,Pt_ARG_TEXT_STRING,tmp,	strlen(tmp));

    sprintf(tmp,"Joy2:\n\nX:%f\nY:%f\nR:%f", Joy2.Xcal, Joy2.Ycal, Joy2.Rcal);
    PtSetResource(ABW_mtJoy2Info,Pt_ARG_TEXT_STRING,tmp,	strlen(tmp));
    
	sprintf(tmp,"POS: L %i | R %i | B %i  BRAKE: L %i | R %i | B %i", (int)gfeed.StrutLPosition,  (int)gfeed.StrutRPosition,  (int)gfeed.StrutBPosition,  (int)gfeed.LBrakeOn,  (int)gfeed.RBrakeOn,  (int)gfeed.BBrakeOn);
    PtSetResource(ABW_DAT2,		Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
  
    sprintf(tmp,"X Velocity out: %f\nY Velocity out: %f\nZ Velocity out: %f\n\n", VelOut.Xvelfinal,  VelOut.Yvelfinal,  VelOut.Zvelfinal);
    sprintf(tmp2,"R counts: %d\nL counts out: %d\nB counts out: %d\n", (int)gState.StrutRCounts, (int)gState.StrutLCounts, (int)gState.StrutBCounts);
    strcat(tmp, tmp2);
    PtSetResource(ABW_mtDebug,	Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
    
    
    joy1dot.x = Joy1.Xcal*100+53;
    joy1dot.y = -Joy1.Ycal*100+53;
    PtSetResource(ABW_Joy1Dot,Pt_ARG_POS,	&joy1dot,	sizeof(PhPoint_t));
   
    joy1start=-Joy1.Rcal*1800;
    joy1end=joy1start+1800;
    PtSetResource(ABW_Joy1Dot,Pt_ARG_ARC_START,	joy1start,	sizeof(unsigned short));
    PtSetResource(ABW_Joy1Dot,Pt_ARG_ARC_END,	joy1end,	sizeof(unsigned short));
   
    joy2dot.x = Joy2.Xcal*100+53;
    joy2dot.y = -Joy2.Ycal*100+53;
    PtSetResource(ABW_Joy2Dot,Pt_ARG_POS,	&joy2dot,	sizeof(PhPoint_t));
    joy2start=-Joy2.Rcal*1800;
    joy2end=joy2start+1800;
    PtSetResource(ABW_Joy2Dot,Pt_ARG_ARC_START,	joy2start,	sizeof(unsigned short));
    PtSetResource(ABW_Joy2Dot,Pt_ARG_ARC_END,	joy2end,	sizeof(unsigned short));
    
    //Do Play+Record progress
    if(bRecording==1)
    {
    	PtSetResource(ABW_PRSLIDER,	Pt_ARG_GAUGE_VALUE,	(long)((100.0 / 999999.0) * rCurframe),	sizeof(long));
    	sprintf(tmp2,"Current Frame: %i / %i", (int)rCurframe, (int)999999);
    	PtSetResource(ABW_PRLABEL,	Pt_ARG_TEXT_STRING,	tmp2,	strlen(tmp2));
    	sprintf(tmp2,"Status:Recording");
    	PtSetResource(ABW_PRSTATUS,	Pt_ARG_TEXT_STRING,	tmp2,	strlen(tmp2));
    	
    }
    else
    {
    	if(bPlaying==1)
    	{
    		PtSetResource(ABW_PRSLIDER,	Pt_ARG_GAUGE_VALUE,	(long)((100.0 / gPlayback.numframes) * pCurframe),	sizeof(long));
     		sprintf(tmp2,"Current Frame: %i / %i (%.02f seconds)", (int)pCurframe, (int)gPlayback.numframes, (float)gPlayback.numframes*20.0/1000.0);
    		PtSetResource(ABW_PRLABEL,	Pt_ARG_TEXT_STRING,	tmp2,	strlen(tmp2));
     		sprintf(tmp2,"Status:Playing");
    		PtSetResource(ABW_PRSTATUS,	Pt_ARG_TEXT_STRING,	tmp2,	strlen(tmp2));
    	
    	}
    	else
    	{
    		PtSetResource(ABW_PRSLIDER,	Pt_ARG_GAUGE_VALUE,	0,	sizeof(long));
      		sprintf(tmp2,"Current Frame: %i / %i (%.02f seconds)", (int)0, (int)gPlayback.numframes, (float)gPlayback.numframes*20.0/1000.0);
    		PtSetResource(ABW_PRLABEL,	Pt_ARG_TEXT_STRING,	tmp2,	strlen(tmp2));
    		sprintf(tmp2,"Status:Stopped");
    		PtSetResource(ABW_PRSTATUS,	Pt_ARG_TEXT_STRING,	tmp2,	strlen(tmp2));
    	}
    }
    
    
    //Get Slider Values
    PtGetResource(ABW_SlRollScale, Pt_ARG_GAUGE_VALUE, &flags, 0);
    memcpy(&VelOut.RollScale,flags, sizeof(long));
    PtGetResource(ABW_SlPitchScale, Pt_ARG_GAUGE_VALUE, &flags, 0);
    memcpy(&VelOut.PitchScale,flags, sizeof(long));
    PtGetResource(ABW_SlHeaveScale, Pt_ARG_GAUGE_VALUE, &flags, 0);
    memcpy(&VelOut.HeaveScale,flags, sizeof(long));
    PtGetResource(ABW_SlYawScale, Pt_ARG_GAUGE_VALUE, &flags, 0);
    memcpy(&VelOut.YawScale,flags, sizeof(long));

 	
    //Get Checkboxes
    PtGetResource(ABW_CACTIVE, Pt_ARG_FLAGS, &flags, 0);
    if(*flags & Pt_SET)
    {
        bActive=1;
    }
    else
    {
        bActive=0;
    }
    
    PtGetResource(ABW_CHOME, Pt_ARG_FLAGS, &flags, 0);
    if(*flags & Pt_SET)
    {
        bHome=1;
    }
    else
    {
        bHome=0;
    }
    
    PtGetResource(ABW_CREACT, Pt_ARG_FLAGS, &flags, 0);
    if(*flags & Pt_SET)
    {
        bReact=1;
    }
    else
    {
        bReact=0;
    }

    //Safety for Check Boxes
    if(bActive==0)
    {
        PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST |Pt_BLOCKED|Pt_SET, Pt_GHOST|Pt_BLOCKED|Pt_SET );    
        PtSetResources( ABW_CHOME, 2, args );    
        PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST |Pt_BLOCKED|!Pt_SET, Pt_GHOST|Pt_BLOCKED|Pt_SET );
        PtSetResources( ABW_CREACT, 2, args );
 	    PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	    PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);  
	    PtSetResources( ABW_PLAY, 3, args );
	    PtSetResources( ABW_RECORD, 3, args );
	    PtSetResources( ABW_STOP, 3, args );   
	    PtSetResources( ABW_ZERO, 3, args ); 
    } else {
	    if(bHome==0 && bRecording == 0 && bPlaying == 0)
	    {
	        PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
	        PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
	        PtSetResources( ABW_CREACT, 3, args ); 
	    	PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        PtSetResources( ABW_ZERO, 3, args ); 
	    } else {

			if(bZero==0)
			{
	    		PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
	        	PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
	        	PtSetResources( ABW_ZERO, 3, args );
			} 
	    	PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        PtSetResources( ABW_CREACT, 3, args ); 
	    }
	    if(bReact==0)
	    {
	    	if(bZero==0)
	    	{
	    		PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
	        	PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);
	        	PtSetResources( ABW_CHOME, 3, args ); 
	    	}       

	    	PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);  
	        PtSetResources( ABW_PLAY, 3, args );
	        PtSetResources( ABW_RECORD, 3, args );
	        PtSetResources( ABW_STOP, 3, args );
		        
	    } else {
	    	PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        PtSetResources( ABW_CHOME, 3, args );
	        if(bRecording==1)
	        {
		        PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
		        PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
		        PtSetResources( ABW_PLAY, 3, args ); 
		        
		        PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
		        PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
		        PtSetResources( ABW_STOP, 3, args ); 
		        
		        PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        	PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        	PtSetResources( ABW_CREACT, 3, args ); 
	        	
	        	PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        	PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        	PtSetResources( ABW_CACTIVE, 3, args ); 
	        		
	        } else {
	        	if(bPlaying == 1)
	        	{
	        		PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        		PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        		PtSetResources( ABW_RECORD, 3, args ); 
	        
	        		PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
	        		PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
	        		PtSetResources( ABW_STOP, 3, args );
	        		
	        		PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        		PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        		PtSetResources( ABW_CREACT, 3, args ); 
	        		
	        		PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        		PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        		PtSetResources( ABW_CACTIVE, 3, args ); 
	        		
	        		
	        	} else {
	        		PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
	        		PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
	        		PtSetResources( ABW_PLAY, 3, args ); 
	        		PtSetResources( ABW_RECORD, 3, args ); 
	        		PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
	        		PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);       
	        		PtSetResources( ABW_STOP, 3, args );
	        		
			        PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
		        	PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
		        	PtSetResources( ABW_CREACT, 3, args ); 
		        	
		        	PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
		        	PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
		        	PtSetResources( ABW_CACTIVE, 3, args ); 
	        	}
	        }  
	    } 	    	    
    }
    
    //Set Accelerometer Display
    PtSetResource(ABW_ACC,	Pt_ARG_GAUGE_VALUE, (long)gConsole.analogin[7] * 100/16000,	sizeof(long));
    
    //Set strut display
    PtSetResource(ABW_LS,	Pt_ARG_GAUGE_VALUE,	-gRecord.A.motorpos * 100/140000,	sizeof(long));
    PtSetResource(ABW_BS,	Pt_ARG_GAUGE_VALUE,	-gRecord.B.motorpos * 100/140000,	sizeof(long));
    PtSetResource(ABW_RS,	Pt_ARG_GAUGE_VALUE,	-gRecord.C.motorpos * 100/140000,	sizeof(long));
    sprintf(tmp, "%i", (int)-gRecord.A.motorpos);
    PtSetResource(ABW_lblLS,	Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
    sprintf(tmp, "%i", (int)-gRecord.B.motorpos);
    PtSetResource(ABW_lblBS,	Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
    sprintf(tmp, "%i", (int)-gRecord.C.motorpos);
    PtSetResource(ABW_lblRS,	Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
    
    PtSetResource(ABW_MS,	Pt_ARG_ARC_START,	-450 + -gRecord.D.motorpos * 0.5,	sizeof(long));
    PtSetResource(ABW_MS,	Pt_ARG_ARC_END,	2250 + -gRecord.D.motorpos * 0.5,	sizeof(long));
    sprintf(tmp, "%i", (int)-gRecord.D.motorpos);
    PtSetResource(ABW_lblMS,	Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
    
    //Read Limits
  	if(gRecord.D.switches & 4){gLimits.Rmin=0;}else{gLimits.Rmin=1;}
   	if(gRecord.D.switches & 8){gLimits.Rmax=0;}else{gLimits.Rmax=1;}
  	if(gRecord.C.switches & 4){gLimits.Zmin=0;}else{gLimits.Zmin=1;}
   	if(gRecord.C.switches & 8){gLimits.Zmax=0;}else{gLimits.Zmax=1;}
  	if(gRecord.B.switches & 4){gLimits.Ymin=0;}else{gLimits.Ymin=1;}
   	if(gRecord.B.switches & 8){gLimits.Ymax=0;}else{gLimits.Ymax=1;}
  	if(gRecord.A.switches & 4){gLimits.Xmin=0;}else{gLimits.Xmin=1;}
   	if(gRecord.A.switches & 8){gLimits.Xmax=0;}else{gLimits.Xmax=1;}
   	
   	
   	//E-Stop Check
   	if(gRecord.I.input[0] & 16){EStopFault=1;}else{EStopFault=0;}
   	if(EStopFault)
   	{
   		if(bEStop==0)
   		{
			strcpy(statusstr,statusnew);
			strcpy(statusnew,"E-Stop Error Occured! Deactivating.\n");
			strcat(statusnew,statusstr);
			PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
	    	PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST |Pt_BLOCKED|!Pt_SET, Pt_GHOST|Pt_BLOCKED|Pt_SET );    
	    	PtSetResources( ABW_CACTIVE, 2, args );
	    	bEStop=1;
   		}
   	}
   	else
   	{
   		if(bEStop==1)
   		{
   			PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST |!Pt_BLOCKED, Pt_GHOST|Pt_BLOCKED );    
	    	PtSetResources( ABW_CACTIVE, 2, args );
	    	bEStop=0;
   		}
   	}
   							   	
   	//Check any bits
    if(gRecord.I.input[0] & 1){inputbits[0]=1;}else{inputbits[0]=0;}
   	if(gRecord.I.input[0] & 2){inputbits[1]=1;}else{inputbits[1]=0;}	  		
  	if(gRecord.I.input[0] & 4){inputbits[2]=1;}else{inputbits[2]=0;}
   	if(gRecord.I.input[0] & 8){inputbits[3]=1;}else{inputbits[3]=0;}
   	if(gRecord.I.input[0] & 16){inputbits[4]=1;}else{inputbits[4]=0;}
   	if(gRecord.I.input[0] & 32){inputbits[5]=1;}else{inputbits[5]=0;}
   	if(gRecord.I.input[0] & 64){inputbits[6]=1;}else{inputbits[6]=0;}
   	if(gRecord.I.input[0] & 128){inputbits[7]=1;}else{inputbits[7]=0;}
   		       		    
	//Print Records
	sprintf(tmp2,"POS: %i, %i, %i, %i  LIMITR %i, %i LIMITXYZ: %i, %i, %i NetFault: %i E: %i%i%i%i%i%i%i%i",(int)gRecord.A.refpos,(int)gRecord.B.refpos,(int)gRecord.C.refpos,(int)gRecord.D.refpos, (int)gLimits.Rmin,(int)gLimits.Rmax,(int)gLimits.Xmax,(int)gLimits.Ymax,(int)gLimits.Zmax,(int)NetFault,inputbits[0],inputbits[1],inputbits[2],inputbits[3],inputbits[4],inputbits[5],inputbits[6],inputbits[7]);
    
    sprintf(tmp2,"%d",PitchDifferential);
    
    PtSetResource(ABW_DAT2,	Pt_ARG_TEXT_STRING,	tmp2, strlen(tmp2));
    
   // PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusstr,	strlen(statusstr));

}

void DoGalil()
{
	
	//copy data into structure
	long tmpHead={0};
    //char * pch;
 	
	memcpy(&tmpHead,&mdf,sizeof(long));
	if(tmpHead==9179012) //unique header
	{
		memcpy(&gRecord,&mdf,sizeof(struct gsAllRecord));
	}
 	//return;
 	
 	
 	//the rest here is old and unused
        //pch=strtok(mdf," ");

        //is input
        if(strncmp(mdf,"TEER",4)==0)
        {
        	if(bPOSERR==0)
        	{
        			strcpy(statusstr,statusnew);
					strcpy(statusnew,"Position Error Occured! Deactivating.\n");
					strcat(statusnew,statusstr);
					PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
        	//strcat(statusstr,"Position Error Occoured - Deactivating!\n");
        	PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST |Pt_BLOCKED|!Pt_SET, Pt_GHOST|Pt_BLOCKED|Pt_SET );    
        	PtSetResources( ABW_CACTIVE, 2, args );
        	delay(1000);
        	DoShut();
        	bPOSERR=1;
        	}
        }
        if(strncmp(mdf,"WTD",3)==0)
        {
        	//watchdog for netfault
        	ntftime=clock();
        }
}

void DoReceive()
{
    mrecv();
    jrecv();
    mrecvf();
    jrecvf();
}
void DoJoystickInit()
{
		strcpy(statusstr,statusnew);
		strcpy(statusnew,"Recalibrated Joysticks!\n");
		strcat(statusnew,statusstr);
		PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
        // Joystick init
        Joy1.Xmin=100;
		Joy1.Ymin=100;
		Joy1.Rmin=100;
		Joy1.Xmax=-100;
		Joy1.Ymax=-100;
		Joy1.Rmax=-100;

        Joy2.Xmin=100;
		Joy2.Ymin=100;
		Joy2.Rmin=100;
		Joy2.Xmax=-100;
		Joy2.Ymax=-100;
		Joy2.Rmax=-100;	
	
}
void DoStart()
{
	starttime=clock();
		strcpy(statusstr,statusnew);
		strcpy(statusnew,"Starting Up...\n");
		strcat(statusnew,statusstr);
		PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
    //Series3
    msend( "NTF=1\xD");  //watchdog
    msend("SB7\xD");
    delay(200);
    msend("ER*=1000\xD"); //POS ERROR TRIGGER
    
//    msend("BL-136842,-136842,-136842;FL1000,1000,1000;PT1,1,1,1;DP0,0,0\xD");
    msendf ("CFI\xD");
    jsendf ("CFI\xD");
    msend("CW2\xD");  //give us something readable
    jsend("CW2\xD");  //give us something readable
		strcpy(statusstr,statusnew);
		strcpy(statusnew,"Ready!\n");
		strcat(statusnew,statusstr);
		PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
    
}
void DoShut()
{
	strcat(statusstr,"Shutting Down...\n");
    //Series3
    delay(100);
    msend("CB1,2,3,4\xD");
    msend("AB1\xD");
    msend("MO\xD");
    sleep(1);
    msend("CB 7\xD");

    
}
void DoSafety()
{
    //check estop
    if(EStopFault == 1)
    {
        //frmMain.lblEstop.Visible = True
    }
    else
    {
        //frmMain.lblEstop.Visible = False
    }

}
void DoLoop()
{
	//SocketInit
	if(bSInit==0)
	{
		sckstart();                         //start sockets
		bSInit=1;
	}
		        
		
    //Init
    if(bInit==0)
    {
        //strcpy(mip,"192.168.0.101");            //copy ip
        //mport=4000;                            //copy port
        //strcpy(jip,"192.168.0.99");            //copy ip
        //jport=3000;                            //copy port
        delay(100);
		DoJoystickCode();
        delay(100);
        DoCode();
        delay(100);
        DoStart();                             //init machine
        
        delay(100);
        bInit=1;                             //
		
        //bActive=1;//debug
        bHome=1;       
    }

    //Process Motion+Joystick Galil Data
    DoReceive();
    if(strlen(mdf)>0)
    {
        DoGalil();
    }
    if(strlen(jdf)>0)
    {  
        DoJoystick();
    }

    //Zero
    if(bZero==1)
    {
    	DoZero();
		return;
    }


	//Active
    if(bActive)
    {
        if(bReady == 0)
        {
            bPOSERR=0;						//Reset pos error
            msend("SH\xD");             	// Enable drives as soon as active
            msend("DC*=150000\xD");      	// Force acceleration low
            msend("AC*=150000\xD");        
            msend("SB 1\xD");            	// turn off brakes
            msend("SB 2\xD");
            msend("SB 3\xD");
        	msend("SB 4\xD");
            msend("PT1,1,1,1\xD");        	// position tracking on
            //msend("JG0,0,0,0\xD");          // reset jog
            msend("BG\xD");

            bReady = 1;                    	// we're ready for motion!
        }
		
		//Homed
        if(bHome && !bReact)
        {
            // home position
            gState.StrutRInches = 0;
            gState.StrutLInches = 0;
            gState.StrutBInches = 0;
            msend("PT1,1,1,1\xDBG\xD");					// Turn on position tracking in case we hit a limit
            msend("SP15000,15000,15000,15000\xD");      // Force speed low, rear faster for drop
        }
        
        //UnHomed
        if(!bHome && !bReact)
        {
            // unhome position
            gState.StrutRInches = CenterInches;
            gState.StrutLInches = CenterInches;
            gState.StrutBInches = CenterInches;
            msend("PT1,1,1,1;\xD");					 // Turn on position tracking in case we hit a limit
            msend("SP15000,15000,15000,15000\xD");       // Force speed low, rear slower for rise
        }

		//Reaction
        if(bReact)
        {
            if (bReactInit == 0)
            {
            	sprintf(tmp,"PT0,0,0,0\xD");
            	msend(tmp);
            	sprintf(tmp,"JG0,0,0,0\xD");
        		msend(tmp); 				//send command
        		msend("BG\xD");

            	bReactInit = 1;
            }
        
            if (bReactInit == 1)
            {	
            	VelOut.RollVel = 25000 * Joy2.Xcal;
            	VelOut.PitchVel = 25000 * Joy2.Ycal;
            	VelOut.VertVel = 25000 * Joy1.Ycal;
            	VelOut.YawVel = 1000 * Joy2.Rcal;
            	
            	VelOut.Xvelfinal = (int) VelOut.RollVel*VelOut.RollScale*0.2;
            	VelOut.Yvelfinal = (int) -VelOut.RollVel*VelOut.RollScale*0.1;
            	VelOut.Zvelfinal = (int) VelOut.PitchVel*VelOut.PitchScale*0.1;
            	VelOut.Rvelfinal = (int) VelOut.YawVel*VelOut.YawScale*0.1;         	
            	
            	VelOut.Xvelfinal += (int) VelOut.VertVel*VelOut.HeaveScale*0.1;
            	VelOut.Yvelfinal += (int) VelOut.VertVel*VelOut.HeaveScale*0.1;
            	VelOut.Zvelfinal += (int) VelOut.VertVel*VelOut.HeaveScale*0.1;
	       	
            	if (bPlaying==1)
            	{
            		if (-gRecord.A.motorpos > 135000 && gPlayback.axisA[pCurframe] > 0) gPlayback.axisA[pCurframe] = 0;
	            	if (-gRecord.A.motorpos < 2000 && gPlayback.axisA[pCurframe] < 0) gPlayback.axisA[pCurframe] = 0;
	
	            	if (-gRecord.B.motorpos > 135000 && gPlayback.axisC[pCurframe] > 0) gPlayback.axisC[pCurframe] = 0;
	            	if (-gRecord.B.motorpos < 2000 && gPlayback.axisC[pCurframe] < 0) gPlayback.axisC[pCurframe] = 0;
	            	
	            	if (-gRecord.C.motorpos > 135000 && gPlayback.axisB[pCurframe] > 0) gPlayback.axisB[pCurframe] = 0;
	            	if (-gRecord.C.motorpos < 2000 && gPlayback.axisB[pCurframe] < 0) gPlayback.axisB[pCurframe] = 0;
	            	
	            	if (gRecord.D.motorpos > 1500 && gPlayback.axisD[pCurframe] > 0) gPlayback.axisD[pCurframe] = 0;
	            	if (gRecord.D.motorpos < -1500 && gPlayback.axisD[pCurframe] < 0) gPlayback.axisD[pCurframe] = 0;
	            	
            		sprintf(tmp,"JG%i,%i,%i,%i\xD", (int)-gPlayback.axisA[pCurframe],  (int)-gPlayback.axisC[pCurframe], (int)-gPlayback.axisB[pCurframe], (int)gPlayback.axisD[pCurframe]);
            		
            		pCurframe++;
            		
            		if(pCurframe>gPlayback.numframes)
            		{
            			bPlaying=0;
            			//uncheck react
	    				PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_SET, Pt_SET );    
	    				PtSetResources( ABW_CREACT, 2, args ); 
	    				//unghost active
						PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
						PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
						PtSetResources( ABW_CACTIVE, 3, args ); 
            			//click stop
            			//memset( &cinfo, 0x0, sizeof(PtCallbackInfo_t) );
            			//cinfo.reason = Pt_CB_ACTIVATE;
            			//PtInvokeCallbackType( ABW_STOP,Pt_CB_ACTIVATE,&cinfo );
            			
            		}
            	}
            	else
            	{
            		
	            	if (-gRecord.A.motorpos > 135000 && VelOut.Xvelfinal > 0) VelOut.Xvelfinal = 0;
	            	if (-gRecord.A.motorpos < 2000 && VelOut.Xvelfinal < 0) VelOut.Xvelfinal = 0;
	
	            	if (-gRecord.B.motorpos > 135000 && VelOut.Zvelfinal > 0) VelOut.Zvelfinal = 0;
	            	if (-gRecord.B.motorpos < 2000 && VelOut.Zvelfinal < 0) VelOut.Zvelfinal = 0;
	            	
	            	if (-gRecord.C.motorpos > 135000 && VelOut.Yvelfinal > 0) VelOut.Yvelfinal = 0;
	            	if (-gRecord.C.motorpos < 2000 && VelOut.Yvelfinal < 0) VelOut.Yvelfinal = 0;
            		
            		if (gRecord.D.motorpos > 1500 && VelOut.Rvelfinal > 0) VelOut.Rvelfinal = 0;
	            	if (gRecord.D.motorpos < -1500 && VelOut.Rvelfinal < 0) VelOut.Rvelfinal = 0;
            		
            		PitchDifferential = (abs(-gRecord.A.motorpos + -gRecord.C.motorpos) / 2) - -gRecord.B.motorpos;
            		
            		if (abs(PitchDifferential) > 65000)
            		{
            			VelOut.Xvelfinal = 0;
            			VelOut.Yvelfinal = 0;
            		}
            		
            		if (PitchDifferential > 65000 && VelOut.Zvelfinal < 0) 
            		{
            			VelOut.Zvelfinal = 0;		
            		}
            		
            		if (PitchDifferential < -65000 && VelOut.Zvelfinal > 0) 
            		{
            			VelOut.Zvelfinal = 0;	            			
            		}
            		
            		sprintf(tmp,"JG%i,%i,%i,%i\xD", (int)-VelOut.Xvelfinal,  (int)-VelOut.Zvelfinal, (int)-VelOut.Yvelfinal, (int)VelOut.Rvelfinal);
            		if (bRecording==1)
            		{
            			gPlayback.numframes = rCurframe;
            			gPlayback.axisA[rCurframe] =  VelOut.Xvelfinal;
            			gPlayback.axisB[rCurframe] =  VelOut.Yvelfinal;
            			gPlayback.axisC[rCurframe] =  VelOut.Zvelfinal;
            			gPlayback.axisD[rCurframe] =  VelOut.Rvelfinal;
            			gPlayback.posA[rCurframe] = gRecord.A.refpos;
            			gPlayback.posB[rCurframe] = gRecord.B.refpos;
            			gPlayback.posC[rCurframe] = gRecord.C.refpos;
            			gPlayback.posD[rCurframe] = gRecord.D.refpos;
            			
            			rCurframe++;
            			if(rCurframe>99999)
            			{
            				bRecording=0;
	            			//uncheck react
		    				PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_SET, Pt_SET );    
		    				PtSetResources( ABW_CREACT, 2, args ); 
		    				
		    				//unghost active
							PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
							PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);       
							PtSetResources( ABW_CACTIVE, 3, args ); 
						
	            			//click stop
	            			//memset( &cinfo, 0x0, sizeof(PtCallbackInfo_t) );
	            			//cinfo.reason = Pt_CB_ACTIVATE;
	            			//PtInvokeCallbackType( ABW_STOP,Pt_CB_ACTIVATE,&cinfo );
            			}
            		}
            			
            	}   	
        		msend(tmp); 				//send command		
            }
        }
        //UnReact
        else
        {
        
        	if (bReactInit == 1)		// We were just reacting, so we need to go back to
        	{							// position tracking mode
        		msend("AB1\xD");
        		msend("PT1,1,1,1;\xD");
        		bReactInit = 0;
        	}
        		else
       		{
		        //calculate counts
		        gState.StrutRCounts = gState.StrutRInches * 2000.0 * 3.299 * 1.22;
		        gState.StrutLCounts = gState.StrutLInches * 2000.0 * 3.299 * 1.22;
		        gState.StrutBCounts = gState.StrutBInches * 2000.0 * 3.299 * 1.22;
		        
		        //limits
		        if(gState.StrutRCounts < 330) gState.StrutRCounts = 330;
		        if(gState.StrutLCounts < 330) gState.StrutLCounts = 330;
		        if(gState.StrutBCounts < 330) gState.StrutBCounts = 330;
		        if(gState.StrutRCounts > 135842) gState.StrutRCounts = 135842;
		        if(gState.StrutLCounts > 135842) gState.StrutLCounts = 135842;
		        if(gState.StrutBCounts > 135842) gState.StrutBCounts = 135842;
		
		        //create command string
		        sprintf(tmp, "PA-%d,-%d,-%d,-%d\xD", (int)gState.StrutBCounts, (int)gState.StrutLCounts, (int)gState.StrutRCounts, 0);
 				
 				//PtSetResource(ABW_mtDebug,	Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
 				msend(tmp);
       		}
	        
        } 
    }
    	//InActive
    	else
    {
        msend("AB1\xD");  //abort motion
        msend("CB 1\xD"); //brakes on
        msend("CB 2\xD");
        msend("CB 3\xD");
        msend("CB 4\xD");
        msend("MO\xD");   //motors off
        bReady=0;
    }
}

void DoZero()
{
	if(bDidZero==0 && bRZero==0)
	{
		bDidZero=1;
		//safety block checkboxes/buttons
	    PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST, Pt_GHOST);    
		PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_BLOCKED, Pt_BLOCKED);        
		PtSetResources( ABW_CACTIVE, 3, args ); 
		PtSetResources( ABW_CHOME, 3, args ); 
		PtSetResources( ABW_ZERO, 3, args ); 
	
	
	    //msend("SP5000,15000,5000\xD");              //Force speed low, rear faster for drop
	    msend("SH\xD");
	    msend("PT1,1,1;\xD");
	    msend("BG\xD");                            //Restart motion
	    
	    msend("PA100000,100000,100000\xD");         //Guarantee machine's at its lowest point
	    
		strcpy(statusstr,statusnew);
		strcpy(statusnew,"Homing in Progress...\n");
		strcat(statusnew,statusstr);
		PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));		 
	
	    zerotime = clock();
	}
	
	//tTime=(clock() - zerotime) > 200000;
	//tLimit=(gLimits.Xmax && gLimits.Ymax && gLimits.Zmax);
	
    if(  ((clock() - zerotime) > 300000 || (gLimits.Xmax && gLimits.Ymax && gLimits.Zmax))      && bDidZero==1  )
    {
	
	
	    msend("AB1\xD");                              //Stop all motion so we don't pull against brakes
	    msend("CB 1\xD");  
	    msend("CB 2\xD");  
	    msend("CB 3\xD");                             //Turn on the brakes
	    //msend("CB 4\xD");                             //Turn on the brakes

		delay(500);
		
	    msend("MO\xD");                            //Turn off amplifiers
	    msend("DP0,0,0\xD");                        //Reset to zero position

	    msend("PT1,1,1\xD");           //Force position tracking mode on
	    msend("SH\xD"); 
	    msend("BL-136842,-136842,-136842\xD");   
	    msend("FL-300,-300,-300\xD");  
	    msend("BG\xD");                 //Restart motion
	    msend("PA-330,-330,-330\xD");   //Force slight up position to avoid excessive pull-down torque
		
		strcpy(statusstr,statusnew);
		strcpy(statusnew,"3 Axis Homing is complete, beginning with R Axis...\n");
		strcat(statusnew,statusstr);
		PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
		bRZero=1; //we're doing r axis now
		bDidZero=0;
    }
    
    
    
    if(bRDidZero==0 && bRZero==1)
    {
    	//Prepare to Zero R Axis
	    //msend("SH\xD");
	        	bRDidZero=1;
			strcpy(statusstr,statusnew);
			strcpy(statusnew,"Checking Limits\n");
			strcat(statusnew,statusstr); 
			PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	

	    RPOSReverse=0;
	    RPOSForward=0;
	    
	    
	    //already on a R limit switch?
    	if(gLimits.Rmax)
    	{
			strcpy(statusstr,statusnew);
			strcpy(statusnew,"It was on Forward limit, continuing...\n");
			strcat(statusnew,statusstr); 
			PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
    		bStartOnLimit=1;
    		bWasForward=1;
    	}
    	else
    	{
    		if(gLimits.Rmin)
    		{
    			strcpy(statusstr,statusnew);
				strcpy(statusnew,"It was on Reverse limit, continuing...\n");
				strcat(statusnew,statusstr);
				PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
    			bStartOnLimit=1;
    			bWasReverse=1;
    		}
    		else
    		{
    			strcpy(statusstr,statusnew);
				strcpy(statusnew,"It was on no limit, continuing...\n");
				strcat(statusnew,statusstr);
				PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
    			bStartOnLimit=0;
    			bWasReverse=0;
    			bWasForward=0;
    		}
    	}

    	
    }
    
    if(bRDidZero==1 && bRZero==1)
    {
    	msend("AB1;\xD");
	    msend("PT0,0,0,0;\xD");
	    msend("BG;\xD");
	    msend("SB4;\xD");
    	//we were on a limit
    	//if so, move in proper direction until limit is OFF, then toggle bStartOnLimit
    	if(bStartOnLimit)
    	{
    		if(bWasForward)
    		{
    		    if(gLimits.Rmax)
    			{
    				//keep moving
    				sprintf(tmp,"JG,,,%i;\xD", (int)ForwardSpeed);
    				msend(tmp);
    				msend("BG;\xD");
    			}
    			else
    			{
    				//we found the end, record position turn off bStartOnLimit
    				bStartOnLimit=0;
    				RPOSForward=gRecord.D.refpos;
    				bPOSForward=1;
    				RPOSReverse=0;
    				bPOSReverse=0;
	    			strcpy(statusstr,statusnew);
					strcpy(statusnew,"Found Forward POS(Limit Start), continuing...\n");
					strcat(statusnew,statusstr);
					PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
    			}
    		}
    		if(bWasReverse)
    		{
    		    if(gLimits.Rmin)
    			{
    				//keep moving (backward)
    				sprintf(tmp,"JG,,,%i\xD", (int)ReverseSpeed);
    				msend(tmp);
    				msend("BG;\xD");
    			}
    			else
    			{
    				//we found the end, record position turn off bStartOnLimit
    				bStartOnLimit=0;
    				RPOSReverse=gRecord.D.refpos;
    				bPOSReverse=1;
    				RPOSForward=0;
    				bPOSForward=0;
	    			strcpy(statusstr,statusnew);
					strcpy(statusnew,"Found Reverse POS(Limit Start), continuing...\n");
					strcat(statusnew,statusstr);
					PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
    			}
    		}
    	}
    	else
    	{
    				
    	
    	//OKAY were not on any limits, if we recorded a position, work from there.			
    	if(bPOSReverse==0)
    	{
    		if(gLimits.Rmin==0)
    		{
    			//keep moving
    			sprintf(tmp,"JG,,,%i\xD", (int)ForwardSpeed);
    			msend(tmp);
    			msend("BG;\xD");
    		}
    		else
    		{
    			//got it!
    			RPOSReverse=gRecord.D.refpos;
    			bPOSReverse=1;
    			strcpy(statusstr,statusnew);
				strcpy(statusnew,"Found Reverse POS, continuing...\n");
				strcat(statusnew,statusstr);
				PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
    		}
    	}
    	else
    	{
	    	if(bPOSForward==0)
	    	{
	    		if(gLimits.Rmax==0)
	    		{
	    			//keep moving
	    			sprintf(tmp,"JG,,,%i\xD", (int)ReverseSpeed);
	    			msend(tmp);
	    			msend("BG;\xD");
	    		}
	    		else
	    		{
	    			//got it!
	    			RPOSForward=gRecord.D.refpos;
	    			bPOSForward=1;
	    			strcpy(statusstr,statusnew);
					strcpy(statusnew,"Found Forward POS, continuing...\n");
					strcat(statusnew,statusstr);
					PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
	    		}
	    	}
    	}
    	}
    	
    	//if we got both positions, find center and go there now
    	if(bPOSForward && bPOSReverse)
    	{
    		//turn on point tracking
    		//msend("AB1;\xD");
    		msend("AB1;\xD");
    		msend("PT1,1,1,1;\xD");
    		//msend("BG;\xD");
    		//command that position
    		lPF=RPOSForward;
    		lPR=RPOSReverse;
    		lPC=(int)(RPOSForward+((RPOSReverse-RPOSForward) / 2));
    		sprintf(tmp,"PA,,,%i;\xD", (int)(RPOSForward+((RPOSReverse-RPOSForward) / 2)));
    		msend(tmp);
    		//msend("BG;\xD");
    		
			strcpy(statusstr,statusnew);
			strcpy(statusnew,"Commanding Center POS, continuing...\n");
			strcat(statusnew,statusstr);
			PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
    		sleep(2);
    		//just in case
    		//sleep(1);
    			
    		//this is our new zero!
    		msend("DP,,,0\xD");
    		
    		//turn on that brake
    		//msend("CB4\xD");
    		//msend("AB1\xD");
    		//msend("MO\xD");                            //Turn off amplifiers
    		//let us exit this mess
    		bRDidZero=0;
    		bRZero=1;
    	}
    }	
    
    
    
    
	//Everything Done!
	if(bRDidZero==0 && bRZero==1)
	{
		//safety block checkboxes/buttons
	    PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_GHOST, Pt_GHOST);    
		PtSetArg( &args[2], Pt_ARG_FLAGS, !Pt_BLOCKED, Pt_BLOCKED);        
		PtSetResources( ABW_CACTIVE, 3, args ); 
		PtSetResources( ABW_CHOME, 3, args ); 
		PtSetResources( ABW_ZERO, 3, args );
		 
		 
		//uncheck active
		PtSetArg( &args[1], Pt_ARG_FLAGS, !Pt_SET, Pt_SET );    
		PtSetResources( ABW_CACTIVE, 2, args ); 
		bActive=0;
		bZero=0; //done!
		bRDidZero=0;
		bRZero=0;
		bDidZero=0;
		bStartOnLimit=0;
		RPOSReverse=0;
		RPOSForward=0;
		bWasReverse=0;
		bWasForward=0;
		bPOSReverse=0;
		bPOSForward=0;		
		strcpy(statusstr,statusnew);
		strcpy(statusnew,"Homing is Done!\n");
		strcat(statusnew,statusstr);
		PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
	}
}


void DoCode()
{
	strcpy(statusstr,statusnew);
	strcpy(statusnew,"Updating Motion Galil Code...\n");
	strcat(statusnew,statusstr);
	PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));

    memset(code,0,2048);

    strcat(code,"#AUTO\xD");
    strcat(code,"XQ#OUTDAT,1\xD");  //run our code on thread 2
    strcat(code,"EN\xD");
    strcat(code,"#OUTDAT\xD");
    strcat(code,"IF (NTF=0)\xD");
    strcat(code,"CB1,2,3,4\xD");
    strcat(code,"AB1\xD");
    strcat(code,"MO\xD");
    strcat(code,"CB7\xD");
    strcat(code,"ENDIF\xD");
    strcat(code,"NTF=0\xD");
    strcat(code,"MG\"WTD\"\xD");
    strcat(code,"WT6000\xD");

    //strcat(code,"IF @ABS[_TEA] > 10000\xD");
    //strcat(code,"I7=1\xD");
    //strcat(code,"ENDIF\xD");
    //strcat(code,"IF @ABS[_TEB] > 10000\xD");
    //strcat(code,"I7=2\xD");
    //strcat(code,"ENDIF\xD");
    //strcat(code,"IF @ABS[_TEC] > 10000\xD");
    //strcat(code,"I7=3\xD");
    //strcat(code,"ENDIF\xD");
    //strcat(code,"I1=_TI;I2=_TI5;I3=_TI11;I4=@IN[84];I6=_TC\xD");
    //strcat(code,"O1=@OUT[1];O2=@OUT[2];O3=@OUT[3];O4=@OUT[4]\xD");
    //strcat(code,"S1=_TSA;S2=_TSB;S3=_TSC;S4=_TSD\xD");
    //strcat(code,"P1=_PAA;P2=_PAB;P3=_PAC;P4=_PAD\xD");
    //strcat(code,"P1=_TEA;P2=_TEB;P3=_TEC;P4=_TPD\xD");
    //strcat(code,"MG\"INP\",I1{Z6.0},I2,I3,I4,I5,I6,I7\xD");
    //strcat(code,"WT20\xD");
    //strcat(code,"MG\"SYN\",O1{Z6.0},O2,O3,O4,S1,S2,S3,S4,P1,P2,P3,P4\xD");
    //strcat(code,"MG\"SYN\",0{Z6.0},0,0,0,0,0,0,0,P1,P2,P3,P4\xD");
    //strcat(code,"MG\"TEER\"\xD");
    //strcat(code,"IF (PERR=1)\xD");
    //strcat(code,"MG\"TEER\"\xD");
   // strcat(code,"ENDIF\xD");
    strcat(code,"WT20\xD");
    strcat(code,"JP#OUTDAT\xD");
    strcat(code,"EN\xD");
    strcat(code,"#POSERR\xD");
    strcat(code,"CB1,2,3,4\xD");
    strcat(code,"AB1\xD");
    strcat(code,"MO\xD");
    //strcat(code,"PERR=1\xD");
    strcat(code,"MG\"TEER\"\xD");
    strcat(code,"RE1\xD");


    msend("HX\xD");  //stop any code running
    //msend("CFI\xD"); //send to us UDP
    //msend("CW2\xD");  //give us something readable
   // msend("I5=0\xD");
   // msend("PERR=0\xD");
    //msend("I7=0\xD");

    msend("DL\xD"); //begin download
    msend(code); //Mid(code, r + 1, 100)

    msend("\\\xD"); //end upload

    msend("BP\xD"); //burn program
    delay(500);
    //Pause 2000
    msend("BV\xD"); //burn vars
    delay(500);
    //Pause 2000
    msend( "NTF=1\xD");  //watchdog
    //msend("I5=0\xD");
    //msend("I7=0\xD");
    msend("XQ#OUTDAT,1\xD"); //run our code on thread 2
}

void DoCodeClear()
{

    msend("HX\xD");
    msend("DL\xD");
    msend("\\xD");
    msend("BP\xD");
    //Pause 1000
    msend("BV\xD");
    //Pause 1000
}

void DoJoystickCode()
{
	strcpy(statusstr,statusnew);
	strcpy(statusnew,"Updating Enclosure Galil Code...\n");
	strcat(statusnew,statusstr);
	PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));
	memset(code,0,2048);
	strcat(code,"#AUTO\xD");
	strcat(code,"XQ#OUTDAT,2\xD");  //run our code on thread 2
	strcat(code,"XQ#SAFETY,3\xD");  //run our code on thread 2
	strcat(code,"CB1;CB2;CB3;CB4\xD");
	strcat(code,"EN\xD");
	strcat(code,"#OUTDAT\xD");
	strcat(code,"A1=@AN[0];A2=@AN[1];A3=@AN[2];A4=@AN[3]\xD A5=@AN[4];A6=@AN[5]\xD");
	strcat(code,"MG\"ANA\",A1,A2,A3,A4,A5,A6\xD");
	strcat(code,"WT30\xD");
	strcat(code,"JP#OUTDAT\xD");
	strcat(code,"EN\xD");
	
	strcat(code,"#SAFETY\xD");
	//strcat(code,"T0=_TI0;T1=_TI1\xD");
	strcat(code,"DI8=@IN[12];DI11=@IN[11]\xD");
	strcat(code,"DI10=@IN[10];DI9=@IN[9]\xD");
	strcat(code,"DI8=@IN[8];DI7=@IN[7]\xD");
	strcat(code,"DI6=@IN[6];DI5=@IN[5]\xD");
	strcat(code,"DI4=@IN[4];DI3=@IN[3]\xD");
	strcat(code,"DI2=@IN[2];DI1=@IN[1]\xD");
	
	strcat(code,"IF (DI5=0) & (DI6=0) & (DI7=0)\xD");
	strcat(code,"SB4\xD");
	strcat(code,"ELSE\xD");
	strcat(code,"WT200\xD");
	strcat(code,"CB2\xD"); //turn off POWER LED
	//strcat(code,"CB7\xD"); //turn off power outlets
	strcat(code,"MG\"PWR\"\xD");
	strcat(code,"IF (BLINK4=0)\xD");
	strcat(code,"SB4;BLINK4=1;\xD");
	strcat(code,"ELSE\xD");
	strcat(code,"CB4;BLINK4=0;\xD");
	strcat(code,"ENDIF\xD");
	strcat(code,"ENDIF\xD");
	
	
	strcat(code,"IF (DI10=1)\xD"); //key is off go back to beginning
	strcat(code,"CB2\xD"); //turn off POWER LED
	//strcat(code,"CB7\xD"); //turn off power outlets
	
	strcat(code,"WT5\xD");
	strcat(code,"JP#SAFETY\xD");
	strcat(code,"ENDIF\xD");
	
	
	//OKAY key is on now...
	strcat(code,"SB7\xD");
	strcat(code,"SB2\xD");
	//strcat(code,"MG\"PWR\"\xD"); //debug power fail
	
	
	//Pulse Checker

	strcat(code,"WT5\xD");
	strcat(code,"JP#SAFETY\xD");
	strcat(code,"EN\xD");
	
	jsend("HX\xD");  //stop any code running
	jsend("DL\xD"); //begin download
	jsend(code); //Mid(code, r + 1, 100)
	jsend("\\\xD"); //end upload
	jsend("BP\xD"); //burn program
	delay(500);
	jsend("BV\xD"); //burn vars
	delay(500);
	jsend("XQ#OUTDAT,2\xD"); //run our code on thread 2
	jsend("XQ#SAFETY,3\xD"); //run our code on thread 2
}

void DoJoystickCodeClear()
{
	jsend("HX\xD");
	jsend("DL\xD");
	jsend("\\xD");
	jsend("BP\xD");
	usleep(1);
	jsend("BV\xD");
	usleep(1);
}

void DoJoystick()
{	
	//Process Joystick Console Galil Data
    char * pch;
	long tmpHead={0};
    
	memcpy(&tmpHead,&jdf,sizeof(long));
	if(tmpHead==3670151) //unique header
	{
		memcpy(&gConsole,&jdf,sizeof(struct gsConsoleRecord));
		
		//Print Records
		sprintf(tmp,"%i",gConsole.analogout[0]);
		//PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	tmp,	strlen(tmp));
		return;
	}

	
	
	
	pch=strtok(jdf," ");


	//is input
	if(strncmp(pch,"ANA",3)==0)
	{
		pch=strtok(NULL," ");
		Joy2.Xraw = atof(pch);
		pch=strtok(NULL," ");
		Joy2.Yraw = atof(pch);
		pch=strtok(NULL," ");
		Joy2.Rraw = atof(pch);
		pch=strtok(NULL," ");
		Joy1.Xraw = atof(pch);
		pch=strtok(NULL," ");
		Joy1.Yraw = atof(pch);
		pch=strtok(NULL," ");
		Joy1.Rraw = atof(pch);			
	}
	if(strncmp(pch,"PWR",3)==0)
	{
		if(bPOWERR==0)
		{
			bPOWERR=1;
	        strcpy(statusstr,statusnew);
			strcpy(statusnew,"Power Error Occured! Deactivating.\n");
			strcat(statusnew,statusstr);
			PtSetResource(ABW_mtStatusOutput,	Pt_ARG_TEXT_STRING,	statusnew,	strlen(statusnew));	
	        //strcat(statusstr,"Position Error Occoured - Deactivating!\n");
	        PtSetArg( &args[1], Pt_ARG_FLAGS, Pt_GHOST |Pt_BLOCKED|!Pt_SET, Pt_GHOST|Pt_BLOCKED|Pt_SET );    
	        PtSetResources( ABW_CACTIVE, 2, args );
			DoShut();
		}
	}
	// Joystick 1
	
	if (Joy1.Xraw>0)
	{
		if (Joy1.Xraw < Joy1.Xmin) Joy1.Xmin=Joy1.Xraw;
		if (Joy1.Xraw > Joy1.Xmax) Joy1.Xmax=Joy1.Xraw;
		Joy1.Xcal = ((Joy1.Xraw - Joy1.Xmin) / (Joy1.Xmax - Joy1.Xmin)) - .5;
	}
	
	if (Joy1.Yraw>0)
	{
		if (Joy1.Yraw < Joy1.Ymin) Joy1.Ymin=Joy1.Yraw;
		if (Joy1.Yraw > Joy1.Ymax) Joy1.Ymax=Joy1.Yraw;
		Joy1.Ycal = ((Joy1.Yraw - Joy1.Ymin) / (Joy1.Ymax - Joy1.Ymin)) - .5;
	}
	
	if (Joy1.Rraw>0)
	{
		if (Joy1.Rraw < Joy1.Rmin) Joy1.Rmin=Joy1.Rraw;
		if (Joy1.Rraw > Joy1.Rmax) Joy1.Rmax=Joy1.Rraw;
		Joy1.Rcal = ((Joy1.Rraw - Joy1.Rmin) / (Joy1.Rmax - Joy1.Rmin)) - .5;
	}
		
	// Joystick 2
		
	if (Joy2.Xraw>0)
	{
		if (Joy2.Xraw < Joy2.Xmin) Joy2.Xmin=Joy2.Xraw;
		if (Joy2.Xraw > Joy2.Xmax) Joy2.Xmax=Joy2.Xraw;
		Joy2.Xcal = ((Joy2.Xraw - Joy2.Xmin) / (Joy2.Xmax - Joy2.Xmin)) - .5;
	}
	
	if (Joy2.Yraw>0)
	{
		if (Joy2.Yraw < Joy2.Ymin) Joy2.Ymin=Joy2.Yraw;
		if (Joy2.Yraw > Joy2.Ymax) Joy2.Ymax=Joy2.Yraw;
		Joy2.Ycal = ((Joy2.Yraw - Joy2.Ymin) / (Joy2.Ymax - Joy2.Ymin)) - .5;
	}
	
	if (Joy2.Rraw>0)
	{
		if (Joy2.Rraw < Joy2.Rmin) Joy2.Rmin=Joy2.Rraw;
		if (Joy2.Rraw > Joy2.Rmax) Joy2.Rmax=Joy2.Rraw;
		Joy2.Rcal = ((Joy2.Rraw - Joy2.Rmin) / (Joy2.Rmax - Joy2.Rmin)) - .5;
	}
	
	if ((Joy1.Xcal < .1)&&(Joy1.Xcal > -.1)) Joy1.Xcal = 0;
	if ((Joy1.Ycal < .1)&&(Joy1.Ycal > -.1)) Joy1.Ycal = 0;
	if ((Joy1.Rcal < .1)&&(Joy1.Rcal > -.1)) Joy1.Rcal = 0;
	
	if ((Joy2.Xcal < .1)&&(Joy2.Xcal > -.1)) Joy2.Xcal = 0;
	if ((Joy2.Ycal < .1)&&(Joy2.Ycal > -.1)) Joy2.Ycal = 0;
	if ((Joy2.Rcal < .1)&&(Joy2.Rcal > -.1)) Joy2.Rcal = 0;
		
}